--- a/zipl/include/boot.h
+++ b/zipl/include/boot.h
@@ -18,12 +18,139 @@
 #include "disk.h"
 #include "job.h"
 
+#define STAGE2_BLK_CNT_MAX	24 /* Stage 1b can load up to 24 blocks */
+#define STAGE1B_BLK_CNT_MAX	2  /* Stage 1 can load up to 2 blocks */
+
+/* Boot info */
+
+#define BOOT_INFO_VERSION		1
+#define BOOT_INFO_MAGIC			"zIPL"
+
+#define BOOT_INFO_DEV_TYPE_ECKD		0x00
+#define BOOT_INFO_DEV_TYPE_FBA		0x01
+#define BOOT_INFO_DEV_TYPE_SCSI         0x02
+
+#define BOOT_INFO_BP_TYPE_IPL		0x00
+#define BOOT_INFO_BP_TYPE_DUMP		0x01
+
+#ifdef __s390x__
+#define BOOT_INFO_FLAGS_ARCH		0x01
+#else
+#define BOOT_INFO_FLAGS_ARCH		0x00
+#endif
+
+/* SCSI dump super block */
+
+struct scsi_dump_sb {
+	uint64_t        magic;
+	uint64_t        version;
+	uint64_t        part_start;
+	uint64_t        part_size;
+	uint64_t        dump_offset;
+	uint64_t        dump_size;
+	uint64_t        csum_offset;
+	uint64_t        csum_size;
+	uint64_t        csum;
+} __attribute((packed));
+
+#define SCSI_DUMP_SB_MAGIC	0x5a46435044554d50ULL; /* ZFCPDUMP */
+/* To avoid a csum entry of 0 a seed is used */
+#define SCSI_DUMP_SB_SEED	0x12345678
+#define SCSI_DUMP_SB_CSUM_SIZE  4096
+
+/* SCSI dump parameter */
+
+struct scsi_dump_param {
+	uint64_t block;
+	uint64_t reserved;
+} __attribute((packed));
+/* ECKD dump parameter */
+
+struct eckd_dump_param {
+	uint32_t	start_blk;
+	uint32_t	end_blk;
+	uint16_t	blocksize;
+	uint8_t		num_heads;
+	uint8_t		bpt;
+	char		reserved[4];
+} __attribute((packed, may_alias));
+
+/* FBA dump parameter */
+
+struct fba_dump_param {
+	uint64_t	start_blk;
+	uint64_t	blockct;
+} __attribute((packed));
+
+struct boot_info_bp_dump {
+	union {
+		struct eckd_dump_param eckd;
+		struct fba_dump_param fba;
+		struct scsi_dump_param scsi;
+	} param;
+	uint8_t		unused[16];
+} __attribute__ ((packed));
+
+/*
+ * Layout of block pointer for linear devices
+ * e.g. SCSI
+ */
+/* Layout of SCSI disk block pointer */
+struct linear_blockptr {
+	uint64_t blockno;
+	uint16_t size;
+	uint16_t blockct;
+	uint8_t reserved[4];
+} __attribute((packed));
+
+/*
+ * Layout of block pointer for cylinder/head/sector devices
+ * e.g. SCSI or FBA
+ */
+/* Layout of ECKD disk block pointer */
+struct eckd_blockptr {
+	uint16_t cyl;
+	uint16_t head;
+	uint8_t sec;
+	uint16_t size;
+	uint8_t blockct;
+	uint8_t reserved[8];
+} __attribute((packed));
+
+struct boot_info_bp_ipl {
+	union {
+		struct eckd_blockptr eckd;
+		struct linear_blockptr lin;
+	} bm_ptr;
+	uint8_t		unused[16];
+} __attribute__ ((packed));
+
+struct boot_info {
+	char		magic[4];
+	uint8_t		version;
+	uint8_t		bp_type;
+	uint8_t		dev_type;
+	uint8_t		flags;
+	union {
+		struct boot_info_bp_dump dump;
+		struct boot_info_bp_ipl ipl;
+	} bp;
+} __attribute__ ((packed));
+
+struct boot_ccw0 {
+	uint8_t cmd;
+	uint8_t address_hi;
+	uint16_t address_lo;
+	uint8_t flags;
+	uint8_t pad;
+	uint16_t count;
+} __attribute__ ((packed));
 
 /* Boot data structures for FBA disks */
 
 struct boot_fba_locread {
-	uint64_t locate;
-	uint64_t read;
+	struct boot_ccw0 locate;
+	struct boot_ccw0 read;
 } __attribute__ ((packed));
 
 struct boot_fba_locdata {
@@ -34,27 +161,24 @@ struct boot_fba_locdata {
 } __attribute__ ((packed));
 
 struct boot_fba_stage0 {
-	uint64_t PSW;
-	uint64_t READ;
-	uint64_t TIC;
-	uint64_t param1;
-	uint64_t param2;
-	struct boot_fba_locread locread[16];
-	struct boot_fba_locdata locdata[16];
+	uint64_t psw;
+	uint64_t read_ipl;
+	uint64_t tic1;
+	struct boot_fba_locread locread[2];
+	uint64_t tic1b;
+	struct boot_fba_locdata locdata[2];
+	uint64_t reserved[4];
+	struct boot_info boot_info;
 } __attribute__ ((packed));
 
+struct boot_fba_stage1b {
+	struct boot_fba_locread locread[STAGE2_BLK_CNT_MAX];
+	struct boot_fba_locdata locdata[STAGE2_BLK_CNT_MAX];
+	uint8_t unused[448];
+} __attribute__ ((packed));
 
 /* Boot data structures for ECKD disks */
 
-struct boot_eckd_ccw0 {
-	uint8_t cmd;
-	uint8_t address_hi;
-	uint16_t address_lo;
-	uint8_t flags;
-	uint8_t pad;
-	uint16_t count;
-} __attribute__ ((packed));
-
 struct boot_eckd_ccw1 {
 	uint8_t cmd;
 	uint8_t flags;
@@ -63,10 +187,10 @@ struct boot_eckd_ccw1 {
 } __attribute__ ((packed));
 
 struct boot_eckd_ssrt {
-	struct boot_eckd_ccw0 seek;
-	struct boot_eckd_ccw0 search;
-	struct boot_eckd_ccw0 tic;
-	struct boot_eckd_ccw0 read;
+	struct boot_ccw0 seek;
+	struct boot_ccw0 search;
+	struct boot_ccw0 tic;
+	struct boot_ccw0 read;
 } __attribute__ ((packed));
 
 struct boot_eckd_seekarg {
@@ -77,29 +201,30 @@ struct boot_eckd_seekarg {
 	uint8_t pad2;
 } __attribute__ ((packed));
 
-struct boot_eckd_stage0 {
+struct boot_eckd_cdl_stage0 {
 	uint64_t psw;
-	struct boot_eckd_ccw0 read;
-	struct boot_eckd_ccw0 tic;
+	struct boot_ccw0 read;
+	struct boot_ccw0 tic;
 } __attribute__ ((packed));
 
-struct boot_eckd_classic_stage1 {
-	uint64_t param1;
-	uint64_t param2;
-	struct boot_eckd_ssrt ssrt[8];
-	struct boot_eckd_seekarg seek[8];
-} __attribute__ ((packed));
-
-struct boot_eckd_compatible_stage1 {
-	uint64_t param1;
-	uint64_t param2;
-	struct boot_eckd_ccw0 seek;
-	struct boot_eckd_ccw0 search;
-	struct boot_eckd_ccw0 tic;
-	struct boot_eckd_ccw0 read[12];
-	struct boot_eckd_seekarg seekarg;
+struct boot_eckd_ldl_stage0 {
+	uint64_t psw;
+	struct boot_ccw0 read_r0;
+	struct boot_ccw0 read_r1;
 } __attribute__ ((packed));
 
+struct boot_eckd_stage1 {
+	struct boot_eckd_ssrt ssrt[2];
+	struct boot_ccw0 tic1b;
+	struct boot_eckd_seekarg seek[2];
+	struct boot_info boot_info;
+} __attribute__ ((packed));
+
+struct boot_eckd_stage1b {
+	struct boot_eckd_ssrt ssrt[STAGE2_BLK_CNT_MAX];
+	struct boot_eckd_seekarg seek[STAGE2_BLK_CNT_MAX];
+	uint8_t unused[64];
+} __attribute__ ((packed));
 
 /* Stage 2 boot menu parameter structure */
 
@@ -110,7 +235,8 @@ struct boot_stage2_params {
 	uint16_t timeout;
 	uint16_t banner;
 	uint16_t config[BOOT_MENU_ENTRIES + 1];
-};
+	uint64_t config_kdump;
+} __attribute__ ((packed));
 
 
 /* Stage 3 bootloader parameter structure */
@@ -121,12 +247,15 @@ struct boot_stage3_params {
 	uint64_t initrd_len;
 	uint64_t load_psw;
 	uint64_t extra_parm;
-};
+	uint16_t flags;
+} __attribute__ ((packed));
 
+#define STAGE3_FLAG_SCSI		0x0001
+#define STAGE3_FLAG_KDUMP		0x0002
 
 /* Tape IPL bootloader parameter structure */
 
-#define BOOT_TAPE_IPL_PARAMS_OFFSET	0x100
+#define BOOT_TAPE_IPL_PARAMS_OFFSET	0x200
 
 struct boot_tape_ipl_params {
 	uint64_t parm_addr;
@@ -141,7 +270,7 @@ struct mvdump_param {
 	uint32_t	start_blk;
 	uint32_t	end_blk;
 	uint8_t		blocksize;
-	uint8_t		end_sec;
+	uint8_t		bpt;
 	uint8_t		num_heads;
 } __attribute__ ((packed));
 
@@ -153,36 +282,38 @@ struct mvdump_parm_table {
 		(MAX_DUMP_VOLUMES * sizeof(struct mvdump_param))];
 } __attribute__ ((packed));
 
+void boot_get_dump_info(struct boot_info *boot_info, uint8_t dev_type,
+			void *param);
+void boot_get_ipl_info(struct boot_info *boot_info, uint8_t dev_type,
+		       disk_blockptr_t *bm_ptr, struct disk_info *info);
 
 int boot_check_data(void);
 int boot_init_fba_stage0(struct boot_fba_stage0* stage0,
 			 disk_blockptr_t* stage2_list,
 			 blocknum_t stage2_count);
 int boot_get_fba_stage2(void** data, size_t* size, struct job_data* job);
-void boot_init_eckd_classic_stage0(struct boot_eckd_stage0* stage0);
-int boot_init_eckd_classic_stage1(struct boot_eckd_classic_stage1* stage1,
-				  disk_blockptr_t* stage2_list,
-				  blocknum_t stage2_count);
-void boot_init_eckd_compatible_stage0(struct boot_eckd_stage0* stage0);
-int boot_init_eckd_compatible_stage1(
-			struct boot_eckd_compatible_stage1* stage1,
-			struct disk_info* info);
+void boot_init_eckd_ldl_stage0(struct boot_eckd_ldl_stage0 *stage0);
+void boot_init_eckd_cdl_stage0(struct boot_eckd_cdl_stage0 *stage0);
+int boot_init_eckd_stage1(struct boot_eckd_stage1 *stage1,
+			  disk_blockptr_t *stage1b_list,
+			  blocknum_t stage1b_count);
+int boot_init_eckd_stage1b(struct boot_eckd_stage1b *stage1b,
+			   disk_blockptr_t *stage2_list,
+			   blocknum_t stage2_count);
+int boot_init_fba_stage1b(struct boot_fba_stage1b *stage1b,
+			  disk_blockptr_t *stage2_list,
+			  blocknum_t stage2_count);
 int boot_get_eckd_stage2(void** data, size_t* size, struct job_data* job);
+size_t get_stage3_size();
 int boot_get_stage3(void** buffer, size_t* bytecount, address_t parm_addr,
 		    address_t initrd_addr, size_t initrd_len,
-		    address_t image_addr, int extra_parm);
+		    address_t image_addr, int extra_parm, uint16_t flags);
 int boot_get_tape_ipl(void** data, size_t* size, address_t parm_addr,
 		      address_t initrd_addr, address_t image_addr);
 int boot_get_tape_dump(void** data, size_t* size, uint64_t mem);
 int boot_get_eckd_dump_stage2(void** data, size_t* size, uint64_t mem);
 int boot_get_eckd_mvdump_stage2(void** data, size_t* size, uint64_t mem,
 				uint8_t force, struct mvdump_parm_table);
-int boot_init_eckd_classic_dump_stage1(struct boot_eckd_classic_stage1* stage1,
-				       struct disk_info* info);
-int boot_init_eckd_compatible_dump_stage1(
-				struct boot_eckd_compatible_stage1* stage1,
-				struct disk_info* info,
-				int mvdump_switch);
 int boot_get_fba_dump_stage2(void** data, size_t* size, uint64_t mem);
 
 #endif /* BOOT_H */
--- a/zipl/include/bootmap.h
+++ b/zipl/include/bootmap.h
@@ -18,6 +18,7 @@
 
 
 int bootmap_create(struct job_data* job, disk_blockptr_t* program_table,
+		   disk_blockptr_t *scsi_dump_sb_blockptr,
 		   disk_blockptr_t** stage2_list, blocknum_t* stage2_count,
 		   char** device, struct disk_info** new_info);
 void bootmap_store_blockptr(void* buffer, disk_blockptr_t* ptr,
--- a/zipl/include/disk.h
+++ b/zipl/include/disk.h
@@ -47,8 +47,8 @@ typedef enum {
 	disk_type_scsi,
 	disk_type_fba,
 	disk_type_diag,
-	disk_type_eckd_classic,
-	disk_type_eckd_compatible
+	disk_type_eckd_ldl,
+	disk_type_eckd_cdl,
 } disk_type_t;
 
 /* from linux/hdregs.h */
@@ -93,6 +93,8 @@ struct job_target_data;
 
 int disk_get_info(const char* device, struct job_target_data* target,
 		  struct disk_info** info);
+int disk_is_tape(const char* device);
+int disk_is_scsi(const char* device, struct job_target_data* target);
 int disk_get_info_from_file(const char* filename,
 			    struct job_target_data* target,
 			    struct disk_info** info);
@@ -106,8 +108,8 @@ void disk_blockptr_from_blocknum(disk_bl
 				 struct disk_info* info);
 int disk_write_block_aligned(int fd, const void* data, size_t bytecount,
 	  		     disk_blockptr_t* block, struct disk_info* info);
-blocknum_t disk_write_block_buffer(int fd, const void* buffer,
-				   size_t bytecount,
+blocknum_t disk_write_block_buffer(int fd, int fd_is_basedisk,
+				   const void* buffer, size_t bytecount,
 				   disk_blockptr_t** blocklist,
 				   struct disk_info* info);
 void disk_print_devt(dev_t d);
@@ -119,5 +121,6 @@ blocknum_t disk_get_blocklist_from_file(
 					disk_blockptr_t** blocklist,
 					struct disk_info* pinfo);
 int disk_check_subchannel_set(int devno, dev_t device, char* dev_name);
+void disk_print_geo(struct disk_info *data);
 
 #endif /* not DISK_H */
--- a/zipl/include/install.h
+++ b/zipl/include/install.h
@@ -18,6 +18,7 @@
 
 
 int install_bootloader(const char* device, disk_blockptr_t* program_table,
+		       disk_blockptr_t* scsi_dump_sb_blockptr,
 		       disk_blockptr_t* stage2_data, blocknum_t stage2_count,
 		       struct disk_info* info, struct job_data* job);
 int install_tapeloader(const char* device, const char* image,
@@ -29,4 +30,13 @@ int install_dump(const char* device, str
 int install_mvdump(char* const device[], struct job_target_data* target,
 		   int device_count, uint64_t mem, uint8_t force);
 
+int install_fba_stage1b(int fd, disk_blockptr_t **stage1b_list,
+			blocknum_t *stage1b_count, disk_blockptr_t *stage2_list,
+			blocknum_t stage2_count, struct disk_info *info);
+int install_eckd_stage1b(int fd, disk_blockptr_t **stage1b_list,
+			 blocknum_t *stage1b_count,
+			 disk_blockptr_t *stage2_list,
+			 blocknum_t stage2_count, struct disk_info *info);
+int rewind_tape(int fd);
+
 #endif /* INSTALL_H */
--- a/zipl/include/job.h
+++ b/zipl/include/job.h
@@ -22,10 +22,9 @@ enum job_id {
 	job_ipl = 3,
 	job_segment = 4,
 	job_dump_partition = 5,
-	job_dump_fs = 6,
-	job_menu = 7,
-	job_ipl_tape = 8,
-	job_mvdump = 9,
+	job_menu = 6,
+	job_ipl_tape = 7,
+	job_mvdump = 8,
 };
 
 struct job_target_data {
@@ -46,6 +45,7 @@ struct job_ipl_data {
 	address_t image_addr;
 	address_t parm_addr;
 	address_t ramdisk_addr;
+	int is_kdump;
 };
 
 struct job_segment_data {
@@ -55,6 +55,12 @@ struct job_segment_data {
 
 struct job_dump_data {
 	char* device;
+	char* image;
+	char* parmline;
+	char* ramdisk;
+	address_t image_addr;
+	address_t parm_addr;
+	address_t ramdisk_addr;
 	uint64_t mem;
 };
 
@@ -66,17 +72,6 @@ struct job_mvdump_data {
 	uint8_t force;
 };
 
-struct job_dump_fs_data {
-	char* partition;
-	char* image;
-	char* parmline;
-	char* ramdisk;
-	address_t image_addr;
-	address_t parm_addr;
-	address_t ramdisk_addr;
-	uint64_t mem;
-};
-
 struct job_ipl_tape_data {
 	char* device;
 	char* image;
@@ -90,7 +85,7 @@ struct job_ipl_tape_data {
 
 union job_menu_entry_data {
 	struct job_ipl_data ipl;
-	struct job_dump_fs_data dump_fs;
+	struct job_dump_data dump;
 };
 
 struct job_menu_entry {
@@ -117,7 +112,6 @@ struct job_data {
 		struct job_menu_data menu;
 		struct job_segment_data segment;
 		struct job_dump_data dump;
-		struct job_dump_fs_data dump_fs;
 		struct job_ipl_tape_data ipl_tape;
 		struct job_mvdump_data mvdump;
 	} data;
@@ -132,5 +126,6 @@ struct job_data {
 int job_get(int argc, char* argv[], struct job_data** data);
 void job_free(struct job_data* job);
 int type_from_target(char *target, disk_type_t *type);
+int check_job_dump_images(struct job_dump_data* dump, char* name);
 
 #endif /* not JOB_H */
--- a/zipl/include/misc.h
+++ b/zipl/include/misc.h
@@ -25,14 +25,18 @@ struct misc_file_buffer {
 
 
 void* misc_malloc(size_t size);
+int misc_asprintf(char **out, const char *fmt, ...);
 void* misc_calloc(size_t n, size_t size);
 char* misc_strdup(const char* s);
+int misc_open_exclusive(const char* filename);
 int misc_read(int fd, void* buffer, size_t count);
 int misc_read_file(const char* filename, char** buffer, size_t* size,
 		   int nil_terminate);
 int misc_read_special_file(const char* filename, char** buffer, size_t* size,
 			   int nil_terminate);
 int misc_write(int fd, const void* data, size_t count);
+int misc_pwrite(int fd, void *buf, size_t size, off_t off);
+int misc_seek(int fd, off_t off);
 int misc_get_file_buffer(const char* filename,
 			 struct misc_file_buffer* buffer);
 void misc_free_file_buffer(struct misc_file_buffer* file);
@@ -44,5 +48,10 @@ void misc_free_temp_dev(char* device);
 int misc_check_writable_directory(const char* directory);
 int misc_check_readable_file(const char* filename);
 int misc_check_writable_device(const char* devno, int blockdev, int chardev);
+void misc_ebcdic_to_ascii(unsigned char *from, unsigned char *to);
+void misc_ascii_to_ebcdic(unsigned char *from, unsigned char *to);
 
+#define MAX(x, y) ((x) > (y) ? (x) : (y))
+#define ROUNDUP(x, y) ((((x) + ((y) - 1)) / (y)) * (y))
+#define DIV_ROUND_UP(n, d) (((n) + (d) - 1) / (d))
 #endif /* not MISC_H */
--- a/zipl/include/scan.h
+++ b/zipl/include/scan.h
@@ -15,7 +15,7 @@
 
 
 #define SCAN_SECTION_NUM		9
-#define SCAN_KEYWORD_NUM		20
+#define SCAN_KEYWORD_NUM		21
 #define SCAN_KEYWORD_ONLY_NUM		1
 #define SCAN_AUTOMENU_NAME		"zipl-automatic-menu"
 
@@ -49,6 +49,7 @@ enum scan_keyword_id {
 	scan_keyword_targetblocksize = 17,
 	scan_keyword_targetoffset = 18,
 	scan_keyword_defaultauto = 19,
+	scan_keyword_kdump = 20,
 };
 
 enum scan_section_type {
--- a/zipl/include/zipl.h
+++ b/zipl/include/zipl.h
@@ -19,18 +19,20 @@
 #define DISK_LAYOUT_ID			0x00000001
 
 #define ZIPL_STAGE2_LOAD_ADDRESS        0x2000
-#define ZIPL_STAGE3_ENTRY_ADDRESS	0xa028LL
+#define ZIPL_STAGE3_ENTRY_ADDRESS	0xa050LL
 #define DEFAULT_IMAGE_ADDRESS		0x10000LL
+#define KDUMP_IMAGE_ADDRESS		0x10010LL
 #define DEFAULT_STAGE3_ADDRESS          0xa000LL
 #define MINIMUM_ADDRESS 		0x10000LL
 #define ADDRESS_LIMIT 			0x80000000LL
+#define ADDRESS_LIMIT_KDUMP		0x2000000UL /* HSA size: 32 MiB */
 #define UNSPECIFIED_ADDRESS		-1ULL
 #define MAXIMUM_PARMLINE_SIZE 		0x380
 #define MAXIMUM_PHYSICAL_BLOCKSIZE 	0x1000
 
 #define PSW_ADDRESS_MASK		0x000000007fffffffLL
-#define PSW_LOAD			0x0008000080000000LL
-#define PSW_DISABLED_WAIT		0x000a000000000000LL
+#define PSW_LOAD                        0x0008000080000000LL
+#define PSW_DISABLED_WAIT               0x000a000000000000LL
 
 #define KERNEL_HEADER_SIZE		65536
 #define BOOTMAP_FILENAME		"bootmap"
@@ -44,8 +46,12 @@
 #define MENU_DEFAULT_PROMPT		0
 #define MENU_DEFAULT_TIMEOUT		0
 
-#define FSDUMP_IMAGE	STRINGIFY(ZFCPDUMP_DIR) "/" STRINGIFY(ZFCPDUMP_IMAGE)
-#define FSDUMP_RAMDISK	STRINGIFY(ZFCPDUMP_DIR) "/" STRINGIFY(ZFCPDUMP_RD)
+#define FSDUMP_IMAGE	STRINGIFY(ZFCPDUMP_DIR) "/" STRINGIFY(ZFCPDUMP_FS_IMAGE)
+#define FSDUMP_RAMDISK	STRINGIFY(ZFCPDUMP_DIR) "/" STRINGIFY(ZFCPDUMP_FS_RD)
+#define FSDUMP_PART_IMAGE	STRINGIFY(ZFCPDUMP_DIR) "/" \
+					STRINGIFY(ZFCPDUMP_PART_IMAGE)
+#define FSDUMP_PART_RAMDISK	STRINGIFY(ZFCPDUMP_DIR) "/" \
+					STRINGIFY(ZFCPDUMP_PART_RD)
 
 #define MAX_DUMP_VOLUMES		32
 
--- a/zipl/src/Makefile
+++ b/zipl/src/Makefile
@@ -3,11 +3,17 @@ include ../../common.mak
 
 CPPFLAGS += -I../include -I../boot -I../../include \
 	    -DZFCPDUMP_DIR=$(ZFCPDUMP_DIR) \
-	    -DZFCPDUMP_IMAGE=$(ZFCPDUMP_IMAGE) -DZFCPDUMP_RD=$(ZFCPDUMP_RD) \
+	    -DZFCPDUMP_FS_IMAGE=$(ZFCPDUMP_FS_IMAGE) \
+	    -DZFCPDUMP_FS_RD=$(ZFCPDUMP_FS_RD) \
+	    -DZFCPDUMP_PART_IMAGE=$(ZFCPDUMP_PART_IMAGE) \
+	    -DZFCPDUMP_PART_RD=$(ZFCPDUMP_PART_RD) \
 	    -D_FILE_OFFSET_BITS=64
 LDFLAGS += -Wl,-z,noexecstack
-objects = misc.o proc.o error.o scan.o job.o boot.o bootmap.o disk.o \
-	  install.o zipl.o ../boot/data.o
+
+objects = misc.o error.o scan.o job.o boot.o bootmap.o disk.o \
+	  install.o zipl.o $(rootdir)/zipl/boot/data.o \
+	  $(rootdir)/libutil/util_part.o $(rootdir)/libutil/util_proc.o
+
 includes = $(wildcard ../include/*.h)
 zipl_helpers = $(wildcard zipl_helper.*)
 chreipl_helpers = $(subst zipl_,chreipl_, $(zipl_helpers))
@@ -33,5 +39,13 @@ clean:
 .PHONY: all install clean
 
 # Additional manual dependencies
+boot.o: ../boot/data.h
+
+../boot/data.h:
+	make -C ../boot data.h
+
+../boot/data.o:
+	make -C ../boot data.o
 
-boot.o: ../boot/data.o ../boot/data.h
+../../libutil/util_part.o:
+	make -C ../../libutil util_part.o
